/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.utilerias;

import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import com.rjconsultores.ventaboletos.service.PuntoVentaService;
import java.util.ArrayList;
import java.util.List;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.WrongValueException;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zk.ui.event.InputEvent;
import org.zkoss.zkplus.databind.BindingListModel;
import org.zkoss.zkplus.databind.BindingListModelList;
import org.zkoss.zkplus.spring.SpringUtil;
import org.zkoss.zul.Combobox;

/**
 *
 * @author Administrador
 */
public class MyComboboxPuntoVenta extends Combobox {

    private PuntoVentaService puntoVentaService;
    private List<PuntoVenta> lsPuntoVenta;
    private PuntoVenta initialValue;
    private Integer indiceSelected = null;

    public MyComboboxPuntoVenta() {
        super();

        puntoVentaService = (PuntoVentaService) SpringUtil.getBean("puntoVentaService");
        lsPuntoVenta = new ArrayList<PuntoVenta>();

        this.setAutodrop(false);
        this.setAutocomplete(false);

      
        this.addEventListener("onOK", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                String strPuntoVenta = MyComboboxPuntoVenta.this.getText().toUpperCase();
                if (strPuntoVenta.length() < MyComboboxParada.minLength) {
                    return;
                }
                if (!strPuntoVenta.isEmpty()) {
                    lsPuntoVenta = puntoVentaService.buscaLike(strPuntoVenta);

                    BindingListModel listModelPuntoVenta = new BindingListModelList(lsPuntoVenta, true);
                    MyComboboxPuntoVenta.this.setModel(listModelPuntoVenta);
                    indiceSelected = null;
                    if (!lsPuntoVenta.isEmpty()) {
                        indiceSelected = 0;
                    }
                    MyComboboxPuntoVenta.this.open();
                } else {
                    lsPuntoVenta.clear();

                    BindingListModel listModelPuntoVenta = new BindingListModelList(lsPuntoVenta, true);
                    MyComboboxPuntoVenta.this.setModel(listModelPuntoVenta);
                }
            }
        });

        this.addEventListener("onChanging", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                InputEvent ev = (InputEvent) event;
                String strPuntoVenta = ev.getValue();
                if (strPuntoVenta.length() < 2) {
                    lsPuntoVenta.clear();

                    BindingListModel listModelPuntoVenta = new BindingListModelList(lsPuntoVenta, true);
                    MyComboboxPuntoVenta.this.setModel(listModelPuntoVenta);

                    MyComboboxPuntoVenta.this.close();
                }
            }
        });
    }

    public PuntoVenta getInitialValue() {
        return initialValue;
    }

    public void setInitialValue(PuntoVenta initialValue) {
        if (initialValue == null) {
            return;
        }
        List<PuntoVenta> ls = new ArrayList<PuntoVenta>();
        ls.add(initialValue);

        this.setModel(new BindingListModelList(ls, false));
    }

    public void getValue(boolean checaBusqueda) throws WrongValueException {
        if (checaBusqueda) {
            PuntoVenta p = (PuntoVenta) (this.getSelectedItem() == null ? null : this.getSelectedItem().getValue());

            if (p == null) {
                throw new WrongValueException(this, Labels.getLabel("MSG.Error.combobox.hacerBusqueda"));
            }
        } else {
            super.getValue();
        }
    }
}
